// C Header File
// Created 7/23/2003; 10:51:08 PM

//=============================================================================
// returns 0 if move would bring the character too near to a wall
//=============================================================================
short ValidMove(FATCONFIG* fc, short x, short y) {
    #define DIST_FROM_WALL 26
    char *map = fc->map_data;

    // if we would come too near to a solid square...
    if ((*(map+((y+DIST_FROM_WALL)>>6)*fc->map_width+((x+DIST_FROM_WALL)>>6))>0) ||
        (*(map+((y-DIST_FROM_WALL)>>6)*fc->map_width+((x-DIST_FROM_WALL)>>6))>0) ||
        (*(map+((y+DIST_FROM_WALL)>>6)*fc->map_width+((x-DIST_FROM_WALL)>>6))>0) ||
        (*(map+((y-DIST_FROM_WALL)>>6)*fc->map_width+((x+DIST_FROM_WALL)>>6))>0) ||
        (*(actorat+((y+DIST_FROM_WALL)>>6)*fc->map_width+((x+DIST_FROM_WALL)>>6))) ||
        (*(actorat+((y-DIST_FROM_WALL)>>6)*fc->map_width+((x-DIST_FROM_WALL)>>6))) ||
        (*(actorat+((y+DIST_FROM_WALL)>>6)*fc->map_width+((x-DIST_FROM_WALL)>>6))) ||
        (*(actorat+((y-DIST_FROM_WALL)>>6)*fc->map_width+((x+DIST_FROM_WALL)>>6))))
    {
       return 0;        // false
    }
    return 1;           // true
}


//=============================================================================
// move player forward or backward depending on player's angle ...
//
// special player move routine (takes doors into account) AND don't allows
// the user to come too near to a wall, but try to slide automatically.
//=============================================================================
void PlayerMove(FATCONFIG* fc,int forward, short strafe)
{
		short tmp = (strafe) ? +ANGLE_090 : 0;
    short stepx   = FAT_Cos16384(fc->cam_orientation+tmp) >> 11;
    short stepy   = FAT_Sin16384(fc->cam_orientation+tmp) >> 11;
    short newxpos = fc->cam_xpos + ((forward)? stepx: -stepx);
    short newypos = fc->cam_ypos + ((forward)? stepy: -stepy);
    short newxmod = newxpos >> 6;
    short newymod = newypos >> 6;

    //-------------------------------------------------------------------------
    // check if we are still within the map
    //-------------------------------------------------------------------------
    if (newxmod > fc->map_width-1  ||
        newymod > fc->map_height-1 ||
        newxmod < 0 || newymod < 0)
    {
       return;
    }

    if (!ValidMove(fc, newxpos, newypos)) {  // if new position is invalid ...
        // ...but old position is OK, we're against a wall to east or west
        if (ValidMove(fc, fc->cam_xpos, newypos)) {
            // don't change angle if movement is perpendicular to the wall
            if (stepy != 0) {
                // still allow movement along y = parallel to wall
                fc->cam_ypos = newypos;
            }
        }
        // ...but (new x, old y) is OK, we're against a wall to north or south
        if (ValidMove(fc, newxpos, fc->cam_ypos)) {
            // don't change angle if movement is perpendicular to the wall
            if (stepx != 0) {
               // still allow movement along x = parallel to wall
               fc->cam_xpos = newxpos;
            }
        }
        // ...otherwise we're in a corner, so do nothing
        return;
    }

    //-------------------------------------------------------------------------
    // everything okay -> let's set the new position
    //-------------------------------------------------------------------------
    fc->cam_xpos = newxpos;
    fc->cam_ypos = newypos;

    player->tilex = fc->cam_xpos>>6;
    player->tiley = fc->cam_ypos>>6;
}